Attribute VB_Name = "ScrMode"
'     
Public Const DM_BITSPERPEL = &H40000
Public Const DM_PELSWIDTH = &H80000
Public Const DM_PELSHEIGHT = &H100000
Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32

Type DEVMODE
  dmDeviceName As String * CCHDEVICENAME
  dmSpecVersion As Integer
  dmDriverVersion As Integer
  dmSize As Integer
  dmDriverExtra As Integer
  dmFields As Long
  dmOrientation As Integer
  dmPaperSize As Integer
  dmPaperLength As Integer
  dmPaperWidth As Integer
  dmScale As Integer
  dmCopies As Integer
  dmDefaultSource As Integer
  dmPrintQuality As Integer
  dmColor As Integer
  dmDuplex As Integer
  dmYResolution As Integer
  dmTTOption As Integer
  dmCollate As Integer
  dmFormName As String * CCHFORMNAME
  dmUnusedPadding As Integer
  dmBitsPerPel As Integer
  dmPelsWidth As Long
  dmPelsHeight As Long
  dmDisplayFlags As Long
  dmDisplayFrequency As Long
End Type

Declare Function ChangeDisplaySettings Lib "USER32" Alias "ChangeDisplaySettingsA" (lpDevMode As DEVMODE, ByVal dwFalgs As Long) As Long
Declare Function GetDesktopWindow Lib "USER32" () As Long
Declare Function GetDC Lib "USER32" (ByVal hWnd As Long) As Long
Declare Function GetDeviceCaps Lib "GDI32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Function lScreenColorMode() As Long
  '       
  Const PLANES = 14
  Const BITSPIXEL = 12
  Dim hDC As Long
  '
  'hDC = GetDC(GetDesktopWindow())
  'lScreenColorMode = GetDeviceCaps(hDC, PLANES)
  hDC = GetDC(GetDesktopWindow())
  lScreenColorMode = GetDeviceCaps(hDC, BITSPIXEL)
End Function

Public Sub GetVideoMode(lWidth As Long, lHeight As Long, lDepth As Long)
  '    
  lWidth = Screen.Width \ Screen.TwipsPerPixelX
  lHeight = Screen.Height \ Screen.TwipsPerPixelY
  lDepth = lScreenColorMode()
End Sub

Public Sub SetVideoMode(lWidth As Long, lHeight As Long, lDepth As Long)
  '    
  ' lWidth -    
  ' lHeight -    
  ' lDepth -    ( )
  '
  Dim lRet As Long
  Dim dvmData As DEVMODE
  '
  dvmData.dmPelsWidth = lWidth
  dvmData.dmPelsHeight = lHeight
  dvmData.dmBitsPerPel = lDepth
  dvmData.dmSize = Len(dvmData)
  dvmData.dmFields = DM_PELSWIDTH + DM_PELSHEIGHT + DM_BITSPERPEL
  lRet = ChangeDisplaySettings(dvmData, 0)
End Sub
